/***************************************************************************
                          repeatdimdlg.h  -  description
                             -------------------
    begin                : Wed Jun 4 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef REPEATDIMDLG_H
#define REPEATDIMDLG_H

#include "apaintdoc.h"
#include "dialog_ui_repeatDim.h"
#include <qspinbox.h>

class RepeatDimDlg : public RepeatDimDialogUI  {
    Q_OBJECT
public: 
	RepeatDimDlg(QWidget* parent = 0, const char* name = 0);
	~RepeatDimDlg();

  void showDlg();
  void getScaleFactor(double &facX, double &facY, bool forDrawing);
  void getDensity(double &wid, double &hei);
  void getSystem(int &wid, int &hei);
  void setIntegerView(bool enable);
  
signals:

  void scaleFactor(double facX, double facY);
  void scaleFactorChanged();

public slots:

  void okClicked();
  void cancelClicked();
  void layerChanged(Layer *sel);
  void mmWidChanged(const QString&);
  void mmHeiChanged(const QString&);
  void dpiWidChanged(const QString&);
  void dpiHeiChanged(const QString&);
  void threadWidChanged(const QString&);
  void threadHeiChanged(const QString&);
  void systemWidChanged(int val);
  void systemHeiChanged(int val);

private:
  enum FldChange{all, mmwid, mmhei, dpiwid, dpihei, twid, thei};
  
  void setVisualData(FldChange fld);
  void getData();
  void updateImage();
   
  double xdpi, ydpi, xmm, ymm, xthreads, ythreads;
  int xsystem, ysystem;
  Layer *selLayer;
  bool inChangeMode, docLoaded, calcInteger;  
};


#endif
