/***************************************************************************
                          filltool.h  -  description
                             -------------------
    begin                : Wed Mar 5 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FILLTOOL_H
#define FILLTOOL_H

#include <toolbase.h>
#include <qimage.h>
#include <qcolor.h>
#include <qpainter.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>
class QGridLayout;

class DrawInRepeat;
class ApaintDoc;
class Layer;
class QCheckBox;
class QLabel;
class QSpinBox;
class ApaintBrushList;

class FillToolProp: public QWidget {
   Q_OBJECT
public:
   FillToolProp(QWidget *parent, const char *name);
   ~FillToolProp();

   int getTreshold();
   int getFillPercentage();
   
   QCheckBox *cbFillToBorder, *cb8fill, *cbWholeImage;

signals:
  void fillToBorderToggle(bool toggle);
  void fill8way(bool toggle);
  void fillWholeImage(bool toggle);

private:
  QLabel *lbTreshold;
  QSpinBox *sbTreshold;
  QLabel *lbFillPercentage;
  QSpinBox *sbFillPercentage;
  QGridLayout  *gbox;
  QButtonGroup *bg1;
};
  
class FillTool : public ToolBase  {
  Q_OBJECT
public: 
	FillTool(DrawInRepeat *drawp, ApaintDoc *docp, ToolType type, PropObject *propObj);
	~FillTool();

  virtual void mousePressed(QMouseEvent *e, QPainter *pc, QPainter *pi);
  virtual void mousePressedDoit(QMouseEvent *e, QPainter *pc, QPainter *pi);
  virtual void begin();
  virtual void end();
  QRect fillWholeImage(int x, int y, QRect pos, uint setCol, int setColPtr, uint bgCol, int bgColPtr,
                      int treshold, QPainter *p, ApaintImage& img, bool useBrush, ApaintImage *brushImg, int fillPercentage);
  // fills img and returns area of the fill
  QRect fill(int x, int y, QRect pos, uint setCol, int setColPtr, uint bgCol, int bgColPtr,
             bool do8way, bool fillToBorder, int treshold, QPainter *p,
             ApaintImage& img, bool useBrush, ApaintImage *brushImg);

 /* void fill8Recur(int x, int y, int xin, int yin, QRect pos, uint setCol, int setColPtr, uchar red, uchar green, uchar blue, 
                  uint bgCol, int bgColPtr, bool fillToBorder, int treshold, QPainter *p,
                  ApaintImage& img, bool useBrush, ApaintImage *brushImg,  int &x1, int &y1, int &x2, int &y2);   */

signals:
  void colorTableChanged(Layer *selLaye);

protected slots:
  void enableFillToBorder(bool enable);
  void enableFill8way(bool enable);
  void enableFillWholeImage(bool enable);
  
private:
  bool validPoint(int xin, int yin, uchar red, uchar green, uchar blue, uint bgCol, uchar bgColPtr,
                          int treshold, bool diffColor, ApaintImage& img);
  void setPixCol(int xin, int yin, uint col, int colPtr, QPainter *p, ApaintImage& img);
  void setPixColBrush(int xin, int yin, int xd, int yd, QPainter *p, ApaintImage& img, ApaintImage *brushImg);
  
  ButtonState btnPressed;
  DrawInRepeat *draw;
  ApaintDoc *doc;
  bool *protCol;
  int *transTable;
  QImage validMask, brushMask;
  bool doFillToBorder, do8wayFill, aspectDrawSetting, doWholeImage;
  FillToolProp *fillProp;
  ApaintBrushList *bList;
  bool useMaskFill;
  bool equalToFillColor[256]; /* used as an implicit parameter for validPoint() */
};

#endif
