/***************************************************************************
                          layermovetool.h  -  description
                             -------------------
    begin                : Thu Jan 22 2004
    copyright            : (C) 2004-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LAYERMOVETOOL_H
#define LAYERMOVETOOL_H

#include <toolbase.h>

class ApaintDoc;

class LayerMoveTool : public ToolBase  {
  Q_OBJECT
public: 
	 LayerMoveTool(ToolType typ, ApaintDoc *docp, PropObject *propObj);
	~LayerMoveTool();

  virtual void mousePressed(QMouseEvent *e, QPainter *pc, QPainter *pi);
  virtual void mouseReleased(QMouseEvent *e, QPainter *pc, QPainter *pi);
  virtual void mouseMoved(QMouseEvent *e, QPainter *pc, QPainter *pi);
  virtual void keyPress(QKeyEvent *e, QPainter *pc, QPainter *pi);
  void begin();
  
signals:  
  void setCursor(QCursor &cur);
  void unsetCursor();
  void putLayerNum(int num);
  
private:
  void selectLayer(int x, int y);
  void setupCursor(int x, int y);

  ApaintDoc *doc;
  bool layerPressed, inSelection;
  int lastx, lasty;
  QCursor mainCur, allCur, normCur;
};

#endif
